﻿Shader "Custom/Particles/Additive/Particles (Additive)"
{
	Properties 
	{
		_MainTex ("Diffuse (RGBA)", 2D) = "black" {}	
	}
	
	SubShader 
	{
		Tags { "Queue"="Transparent" "IgnoreProjector"="True" "RenderType"="Transparent" }
		Blend OneMinusDstColor One
		AlphaTest Greater .01
		Cull Off
		ZWrite Off
		
		CGPROGRAM
		#pragma surface surf Lambert
		#pragma multi_compile USE_RED USE_GREEN USE_BLUE USE_ALPHA DEFAULT
		#include "UnityCG.cginc"
		
		sampler2D _MainTex;	    
        		
		struct Input 
		{
			half2 uv_MainTex;
			fixed4 color : COLOR;
		};

		void surf (Input IN, inout SurfaceOutput o) 
		{
			fixed4 tex = tex2D(_MainTex, IN.uv_MainTex);
			
			o.Albedo = tex * IN.color.rgb;
			o.Alpha = tex * IN.color.a;
			
			#if USE_RED
			o.Albedo = tex.r * IN.color.rgb;
			o.Alpha = tex.r * IN.color.a;
			#endif
			
			#if USE_GREEN
			o.Albedo = tex.g * IN.color.rgb;
			o.Alpha = tex.g * IN.color.a;
			#endif
			
			#if USE_BLUE
			o.Albedo = tex.b * IN.color.rgb;
			o.Alpha = tex.b * IN.color.a;
			#endif
			
			#if USE_ALPHA
			o.Albedo = tex.a * IN.color.rgb;
			o.Alpha = tex.a * IN.color.a;
			#endif
									
		}
		ENDCG
	}	
	CustomEditor "MultiChannelParticlesMaterialEditor"
}
